<?php

/**
 * @file
 * Run behat tests via drush
 */

/**
 * Implements hook_drush_command().
 */
function behat_testing_drush_command() {
  $items['behat'] = array(
    'description' => 'Run behat tests on the current site',
    'bootstrap' => DRUSH_BOOTSTRAP_MAX,
    'aliases' => array('be'),
    'arguments' => array(
      'tags' => 'List of tag names to restrict the tests to',
    ),
    'options' => array(
      'profile' => 'Profile to use from the behat.yml file. Default is default',
    ),
    'examples' => array(
      'drush be' => 'Run all features tests using the default profile. Current db is cloned and tests run on that clone',
      'drush be --profile=rebuild' => 'Run all feature tests using the rebuild profile. With this profile, the test site\'s db is cleared and the site renistalled. If a module is specified in the behat.yml file then this is then enabled along with all its dependencies.',
    ),
  );

  return $items;
}

/**
 * Drush callback. Run behat tests on the current site
 * based on the yml file located in the sites folder.
 */
function drush_behat_testing_behat() {
  try {
    $cmd = _behat_testing_generate_command('pretty', drush_get_option('profile', 'default'), func_get_args());
    drush_print($cmd);
    drush_shell_proc_open($cmd);
  }
  catch (Exception $e) {
    drush_set_error($e->getMessage());
  }
}
